#ifdef E_MOD_DEVIAN_TYPEDEFS
typedef struct _Config_dEvian_Main Config_dEvian_Main;
typedef struct _Config_dEvian Config_dEvian;

#else

#ifndef E_MOD_CONFIG_H_INCLUDED
#define E_MOD_CONFIG_H_INCLUDED

#define CONFIG_VERSION 42
#define CONFIG_THEME_VERSION 1

/* Struct for the module configuration */
struct _Config_dEvian_Main
{
  /* General Module Settings */
  int conf_version;
  int high_quality;
  int nb_devian;
  const char *theme_picture;
  const char *theme_rss;
  const char *theme_popup;

  /* General Sources Settings */
  const char *sources_picture_data_import_dir;
  int sources_picture_data_import_recursive;
  int sources_picture_data_import_thumbs_warn;
  int sources_picture_default_location;
  int sources_picture_set_bg_purge;
  int sources_rss_timer_s;
  Evas_List *sources_rss_docs;
  int sources_rss_popup_news;
  int sources_rss_popup_news_timer;

  /* General Containers Settings */
  int container_default;
  
  int boxs_always_id;
  int boxs_always_name;
  int boxs_stacking;
  int boxs_default_max_size;
  int boxs_default_anim;
  int boxs_anim_ghost_timer;
  int boxs_nice_resize;
  int boxs_nice_trans;

  /* General Data Settings */
  int data_picture_thumb_default_size;
  int data_picture_cache_size;

  /* Viewers */
  const char *viewer_http;
  const char *viewer_image;

  /* Config for each devian */
  Evas_List *devians_conf;
};

/* Struct for sources config */

struct _Config_dEvian
{
  /* About the source */
  int source_type;
  
  int picture_timer_s;
  int picture_timer_active;
  Rss_Doc *rss_doc; /* Pointer to sources_rss_docs list in dEvianM conf 
		       Not being saved */
  const char *rss_url; /* Copy of rss_doc url 
			  To be saved */
  int rss_timer_s;
  int rss_timer_active;
  int rss_nb_items;
  int rss_popup_news;

  /* About the container */
  int container_type;

  int box_x; /* ...TODO: rename *_source */
  int box_y; /* ...TODO: rename *_source */
  int box_w; /* ...TODO: rename *_source */
  int box_h; /* ...TODO: rename *_source */
  int box_max_size_source;
  int box_speed;
  int box_auto_resize;
  int box_anim;
  int box_allow_overlap;
  int box_infos_show;
  int box_infos_pos;
};


Config_dEvian_Main *devian_config_init(void);
Config_dEvian_Main *devian_config_load(void);
void devian_config_save(void);
void devian_config_devian_save(dEvian *devian);

void devian_config_free(void);
void devian_config_devian_free(dEvian *devian);

Config_dEvian_Main *devian_config_main_new(void);
Config_dEvian *devian_config_devian_new(int source_type, Config_dEvian *conf);

#endif
#endif
