#ifdef E_MOD_DEVIAN_TYPEDEFS
typedef struct _dEvian_Main dEvian_Main;
typedef struct _dEvian dEvian;

#else

#ifndef E_MOD_DEVIAN_H_INCLUDED
#define E_MOD_DEVIAN_H_INCLUDED

#define DEVIAN_VERSION "0.1.6"

#define DEVIAN_THEME_DEFAULT "minimal"
#define DEVIAN_THEME_TYPE_POPUP 0
#define DEVIAN_THEME_TYPE_PICTURE 1 /* Must be the same than SOURCE_PICTURE */
#define DEVIAN_THEME_TYPE_RSS 2 /* Must be the same than SOURCE_RSS */


#define DEVIAN_MAX_PATH 200
#define DEVIAN_ID_LEN 50

#define DEVIAN_VIEWER_HTTP_DEFAULT "firefox"
#define DEVIAN_VIEWER_IMAGE_DEFAULT "exhibit"

#define SIZE_POLICY_DEFAULT 1
#define SIZE_POLICY_AUTO 0
#define SIZE_POLICY_USER 1

dEvian_Main *dEvianM;

/**
 *Struct for dEvian module
 */
struct _dEvian_Main
{
  E_Module *module;
  E_Container *container;
  char *display;

  //Evas_Coord canvas_w, canvas_h;
  int canvas_w, canvas_h;
  Evas_List *devians;

  int container_box_count;
  int container_bar_count;
  int source_picture_count;

  Evas_List *bars;

  Picture_List_Local *picture_list_local;
  Picture_List_Net *picture_list_net;
  Picture_Cache *picture_cache;

  /* Panel */
  E_Config_Dialog *dialog_conf;
  E_Config_Dialog *dialog_conf_theme;
  /* Module config */
  Config_dEvian_Main *conf;
};

/**
 * Struct for each dEvian
 * Each one has a source and a container
 * One dEvian is one information displayed somewhere
 */
struct _dEvian
{
  char *id;

  void *source;
  /* Source actions wich dEvian handles */
  /* ...TODO: Add other actions */
  struct
  {
    void (*timer_change) (dEvian *devian, int active, int time);
    int (*refresh) (dEvian *devian);
    int (*set_bg) (dEvian *devian);
    int (*viewer) (dEvian *devian);
    int (*gui_update) (dEvian *devian);
  } source_func;

  void *container;
  /* Container actions wich dEvian handles */
  /* ...TODO: Add other actions */
  struct
  {
    void (*update_actions) (dEvian *devian);
    void (*resize_auto) (dEvian *devian);
    int (*is_in_transition) (dEvian *devian);
  } container_func;

  int size_policy;
  Popup_Warn *popup_warn;

  /* The devian is going to die */
  int dying;

  Config_dEvian *conf;
  E_Config_Dialog *dialog_conf;
  E_Config_Dialog *dialog_conf_rss;
  E_Menu *menu;
};


/* Functions about dEvian */

int  devian_devian_main_init(E_Module *m);
void devian_devian_main_shutdown(void);

dEvian *devian_devian_add(int source_type, Config_dEvian *cfg_devian);
void    devian_devian_del(dEvian *devian, int now);
void    devian_devian_del_all(void);

void devian_devian_set_id(dEvian *devian, int source, char *c2);


/* Some wrappers for librairies/functionalities used by dEvian */

char *devian_display_init(void);
void  devian_display_shutdown(void);

const char *devian_devian_edje_load(Evas_Object *edje_obj, char *part, int type);

const char *devian_ss_utf8_add(char *text, int tfree);

#endif
#endif
