#include "dEvian.h"


/* Public module routines */

EAPI E_Module_Api e_modapi =
{
   E_MODULE_API_VERSION,
   "dEvian"
};

EAPI void *
e_modapi_init(E_Module *m)
{
  // Init new module
  if (!devian_devian_main_init(m))
    return NULL;
  dEvianM->module = m;

  //Return pointer on struct of module
   return dEvianM;
}

EAPI int
e_modapi_shutdown(E_Module *m)
{
  dEvianM = m->data;

  if (dEvianM)
    devian_devian_main_shutdown();

  DMAIN(("---END---\n"));

  return 1;
}

EAPI int
e_modapi_save(E_Module *m)
{
  if (dEvianM->conf)
    devian_config_save();
  return 1;
}

EAPI int
e_modapi_info(E_Module *m)
{
  char buf [DEVIAN_MAX_PATH];

  snprintf(buf, sizeof(buf), "%s/module_icon.png", e_module_dir_get(m));
  m->icon_file = strdup(buf);
  return 1;
}

EAPI int
e_modapi_about(E_Module *m)
{
   e_module_dialog_show(_("Enlightenment dEvian Module - version " DEVIAN_VERSION),
			_("Module to display informations / pictures on your desktop<br>"
			  "with eye-candy effects<br><br>"
			  "http://oooo.zapto.org<br>"
			  "ooookiwi@free.fr"));
   return 1;
}

EAPI int
e_modapi_config(E_Module *m)
{
  if (!m) return 0;
  if (!m->data) return 0;
  if (!dEvianM) return 0;
  devian_config_dialog_main(e_container_current_get(e_manager_current_get()));
  return 1;
}


/* End of public module routines */
