#ifdef E_MOD_DEVIAN_TYPEDEFS

typedef struct _Source_Rss Source_Rss;

#else

#ifndef E_MOD_SOURCE_RSS_H_INCLUDED
#define E_MOD_SOURCE_RSS_H_INCLUDED

/* Must be multiples of 60 */
#define SOURCE_RSS_UPDATE_RATE_DEFAULT 60*15
#define SOURCE_RSS_UPDATE_RATE_MIN 60
#define SOURCE_RSS_UPDATE_RATE_MAX 60*30

#define SOURCE_RSS_NB_ITEMS_DEFAULT 7

struct _Source_Rss
{
  dEvian *devian;
  
  Evas_Object *obj0;
  Evas_Object *obj1;
  
  Evas_Object *obj_infos;

  Rss_Feed *rss_feed;
  Rss_Article *active_article;

  Ecore_Timer *timer;
};

int devian_source_rss_add(dEvian *devian);
void devian_source_rss_del(Source_Rss *source);

int devian_source_rss_change(dEvian *devian);
int devian_source_rss_set_bg(dEvian *devian);
int devian_source_rss_viewer(dEvian *devian);

int devian_source_rss_evas_object_get(dEvian *devian,
                                          Evas_Object **rss0,
                                          Evas_Object **rss1);
int devian_source_rss_original_size_get(Source_Rss *source,
                                            int part, int *w, int *h);
void devian_source_rss_dialog_infos(Source_Rss *source);
char *devian_source_rss_name_get(Source_Rss *source);
char *devian_source_rss_infos_get(Source_Rss *source);
void devian_source_rss_timer_change(dEvian *devian, int active, int time);

#endif
#endif
